########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../report.4gs/display.4gl  1.2  Delta: 4/30/90
########################################################################

globals "globals.4gl"

#######################################################################
function ct_display(level)
#######################################################################
#  levels:
#   1=new display screen (clear window)
#   2=counting element (count(*))
#   3=preparing elements (open cursor)
#   4=processing elements header
#   5=processing elements (foreach)
#   6=processing complete
#   7=no elements to process
#
    define
        scratch char(76),   # scratch storage
        x       integer,    # working number
        level   smallint    # display level
    case
        when level = 1
            let scratch = "======================================",
                          "======================================"
            display scratch at  3,1
            display scratch at 20,1
            display ct.prcname clipped at 2,2
            let x = 76 - length(ct.rtmargn)
            display ct.rtmargn clipped at 2, x
            let scratch = "Output to:"
            if downshift(ct.prc_only) = "y"
            then
                let scratch = scratch clipped, " no output - process only"
            else
                let scratch = scratch clipped, " ", ct.destin[1,64]
            end if
            let x = (38 - (length(scratch) / 2))
            display scratch clipped at 22,x
        when level = 2
            display "Gathering Elements..." at 10,27
        when level = 3
			display "" at 10,1
			let scratch = ct.num_rows using "Sorting <<<,<<<,<<< Elements..."
            let x = (40 - (length(scratch) / 2))
            display scratch clipped at 10,x
        when level = 4
			display "" at 10,1
            display "Processing Element" at 10,28
            display ct.num_rows using "1 of <<<<<<<<" at 12,34
        when level = 5
            let x = ct.cur_row / ct.quiet
            if (x * ct.quiet) = ct.cur_row or ct.cur_row = ct.num_rows
            then
                display ct.cur_row using "########" at 12,27
            end if
        when level = 6
            display " Processing Complete  " at 10,27
        when level = 7
            display "No Elements to Process" at 10,26
    end case
    return
end function
# ct_display()
