##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../report.4gs/updown.4gl  1.1  Last Delta: 10/26/88
##############################################################################

########################################################################
function updown(str)
# returning str
########################################################################
#  - this function takes a string and capitalizes the first char of
#    each word, and downshifts all proceeding chars.  it does know
#    about Mc. (but not mac or st because MacHine, StOp)
#
	define
		str			char(80),		# string to change
		chr			char(1),		# character to work on
		x			smallint,		# working number
		n			smallint,		# working number
		flags		char(3)			# 1=upshift next char
									# 2=last char was an upshifted M
	
	let flags[1,1] = "y"
	let x = length(str)
	for n = 1 to x
		let chr = str[n,n]
		if (chr >= "A" and chr <= "Z") or (chr >= "a" and chr <= "z")
		then
			if flags[1,1] = "y"
			then
				let chr = upshift(chr)
				let flags[1,1] = "n"
			else
				let chr = downshift(chr)
				# upshift next char if this char is a 'c' and last char
				# was an upshifted "M"
				if chr = "c" and flags[2,2] = "y"
				then
					let flags[1,1] = "y"
				end if
			end if
		else
			let flags[1,1] = "y"
		end if
		if chr = "M"
		then
			let flags[2,2] = "y"
		else
			let flags[2,2] = "n"
		end if
		let str[n,n] = chr
	end for
	return str
end function
# updown()
