########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../report.4gs/ask_quit.4gl  1.2  Delta: 4/30/90
########################################################################

globals "globals.4gl"

#######################################################################
function ct_ask_quit(quit_allowed)
#######################################################################
#   - prompts user for quit and allows shell escape.
#
    define
       cmd char(1),            # prompt answer
       quit_allowed smallint   # allow user to quit?

    while true
      open window ct_inter_win at 8, 5 with 1 rows, 72 columns
          attribute (border, red)
        if quit_allowed
        then
            prompt " Would you like to terminate this process (Y/N)? " 
              for char cmd
            let cmd = upshift(cmd)
            case
              when cmd = "Y"
                clear screen
                exit program (1)
              when cmd = "!"
                call ct_bang()
                current window is win1
                close window ct_inter_win
              otherwise
                let int_flag = 0
                current window is win1
                close window ct_inter_win
                exit while
            end case
        else
            prompt " This process cannot be interrupted.", 
                   "  Press [ENTER to continue. " for char cmd
            case
              when cmd = "!"
                call ct_bang()
                current window is win1
                close window ct_inter_win
              otherwise
                let int_flag = 0
                current window is win1
                close window ct_inter_win
                exit while
            end case
        end if
    end while
end function
# ct_ask_quit

#######################################################################
function ct_bang()
#######################################################################
# shell escape  
#
    define
        cmd char(70),
        x   char(1)

    if not ok_bang() then return end if    # if shell escape is not allowed
    
    let x = "!"
    while x = "!"
        prompt "!" for cmd
        run cmd
        prompt "Press [ENTER] to continue." for char x
    end while

end function
# ct_bang
